function _aws_cdk_aws_ecs_patterns_QueueProcessingEc2ServiceProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_PlacementConstraint(o);
        if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_PlacementStrategy(o);
        if (p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_CapacityProviderStrategy(o);
        if ("desiredTaskCount" in p)
            print("@aws-cdk/aws-ecs-patterns.QueueProcessingServiceBaseProps#desiredTaskCount", "- Use `minScalingCapacity` or a literal object instead.");
        if (p.scalingSteps != null)
            for (const o of p.scalingSteps)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-applicationautoscaling/.warnings.jsii.js")._aws_cdk_aws_applicationautoscaling_ScalingInterval(o);
        if (p.secrets != null)
            for (const o of Object.values(p.secrets))
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_Secret(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_QueueProcessingEc2Service(p) {
}
function _aws_cdk_aws_ecs_patterns_QueueProcessingFargateServiceProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.securityGroups != null)
            for (const o of p.securityGroups)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ec2/.warnings.jsii.js")._aws_cdk_aws_ec2_ISecurityGroup(o);
        if (p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_CapacityProviderStrategy(o);
        if ("desiredTaskCount" in p)
            print("@aws-cdk/aws-ecs-patterns.QueueProcessingServiceBaseProps#desiredTaskCount", "- Use `minScalingCapacity` or a literal object instead.");
        if (p.scalingSteps != null)
            for (const o of p.scalingSteps)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-applicationautoscaling/.warnings.jsii.js")._aws_cdk_aws_applicationautoscaling_ScalingInterval(o);
        if (p.secrets != null)
            for (const o of Object.values(p.secrets))
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_Secret(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_QueueProcessingFargateService(p) {
}
function _aws_cdk_aws_ecs_patterns_QueueProcessingServiceBaseProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_CapacityProviderStrategy(o);
        if ("desiredTaskCount" in p)
            print("@aws-cdk/aws-ecs-patterns.QueueProcessingServiceBaseProps#desiredTaskCount", "- Use `minScalingCapacity` or a literal object instead.");
        if (p.scalingSteps != null)
            for (const o of p.scalingSteps)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-applicationautoscaling/.warnings.jsii.js")._aws_cdk_aws_applicationautoscaling_ScalingInterval(o);
        if (p.secrets != null)
            for (const o of Object.values(p.secrets))
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_Secret(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_QueueProcessingServiceBase(p) {
}
function _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedEc2ServiceProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_PlacementConstraint(o);
        if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_PlacementStrategy(o);
        if (!visitedObjects.has(p.recordType))
            _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedServiceRecordType(p.recordType);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedTaskImageOptions(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedEc2Service(p) {
}
function _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedFargateServiceProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.recordType))
            _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedServiceRecordType(p.recordType);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedTaskImageOptions(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedFargateService(p) {
}
function _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedServiceRecordType(p) {
}
function _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedServiceBaseProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.recordType))
            _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedServiceRecordType(p.recordType);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedTaskImageOptions(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedTaskImageOptions(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.secrets != null)
            for (const o of Object.values(p.secrets))
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_Secret(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedServiceBase(p) {
}
function _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedEc2ServiceProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_PlacementConstraint(o);
        if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_PlacementStrategy(o);
        if (!visitedObjects.has(p.recordType))
            _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedServiceRecordType(p.recordType);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedTaskImageOptions(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedEc2Service(p) {
}
function _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedFargateServiceProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.securityGroups != null)
            for (const o of p.securityGroups)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ec2/.warnings.jsii.js")._aws_cdk_aws_ec2_ISecurityGroup(o);
        if (!visitedObjects.has(p.recordType))
            _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedServiceRecordType(p.recordType);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedTaskImageOptions(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedFargateService(p) {
}
function _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedServiceRecordType(p) {
}
function _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedServiceBaseProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.recordType))
            _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedServiceRecordType(p.recordType);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedTaskImageOptions(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedTaskImageOptions(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.secrets != null)
            for (const o of Object.values(p.secrets))
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_Secret(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedServiceBase(p) {
}
function _aws_cdk_aws_ecs_patterns_ScheduledEc2TaskProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.scheduledEc2TaskDefinitionOptions))
            _aws_cdk_aws_ecs_patterns_ScheduledEc2TaskDefinitionOptions(p.scheduledEc2TaskDefinitionOptions);
        if (!visitedObjects.has(p.scheduledEc2TaskImageOptions))
            _aws_cdk_aws_ecs_patterns_ScheduledEc2TaskImageOptions(p.scheduledEc2TaskImageOptions);
        if (p.securityGroups != null)
            for (const o of p.securityGroups)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ec2/.warnings.jsii.js")._aws_cdk_aws_ec2_ISecurityGroup(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ScheduledEc2TaskImageOptions(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.secrets != null)
            for (const o of Object.values(p.secrets))
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_Secret(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ScheduledEc2TaskDefinitionOptions(p) {
}
function _aws_cdk_aws_ecs_patterns_ScheduledEc2Task(p) {
}
function _aws_cdk_aws_ecs_patterns_ScheduledFargateTaskProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.scheduledFargateTaskDefinitionOptions))
            _aws_cdk_aws_ecs_patterns_ScheduledFargateTaskDefinitionOptions(p.scheduledFargateTaskDefinitionOptions);
        if (!visitedObjects.has(p.scheduledFargateTaskImageOptions))
            _aws_cdk_aws_ecs_patterns_ScheduledFargateTaskImageOptions(p.scheduledFargateTaskImageOptions);
        if (p.securityGroups != null)
            for (const o of p.securityGroups)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ec2/.warnings.jsii.js")._aws_cdk_aws_ec2_ISecurityGroup(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ScheduledFargateTaskImageOptions(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.secrets != null)
            for (const o of Object.values(p.secrets))
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_Secret(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ScheduledFargateTaskDefinitionOptions(p) {
}
function _aws_cdk_aws_ecs_patterns_ScheduledFargateTask(p) {
}
function _aws_cdk_aws_ecs_patterns_ScheduledTaskBaseProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.securityGroups != null)
            for (const o of p.securityGroups)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ec2/.warnings.jsii.js")._aws_cdk_aws_ec2_ISecurityGroup(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ScheduledTaskImageProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.secrets != null)
            for (const o of Object.values(p.secrets))
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_Secret(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ScheduledTaskBase(p) {
}
function _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsServiceBaseProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.loadBalancers != null)
            for (const o of p.loadBalancers)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancerProps(o);
        if (p.targetGroups != null)
            for (const o of p.targetGroups)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_ApplicationTargetProps(o);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedTaskImageProps(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedTaskImageProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.secrets != null)
            for (const o of Object.values(p.secrets))
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_Secret(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ApplicationTargetProps(p) {
}
function _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancerProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.listeners != null)
            for (const o of p.listeners)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_ApplicationListenerProps(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ApplicationListenerProps(p) {
}
function _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsServiceBase(p) {
}
function _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsEc2ServiceProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_PlacementConstraint(o);
        if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_PlacementStrategy(o);
        if (p.loadBalancers != null)
            for (const o of p.loadBalancers)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancerProps(o);
        if (p.targetGroups != null)
            for (const o of p.targetGroups)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_ApplicationTargetProps(o);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedTaskImageProps(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsEc2Service(p) {
}
function _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsFargateServiceProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.loadBalancers != null)
            for (const o of p.loadBalancers)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancerProps(o);
        if (p.targetGroups != null)
            for (const o of p.targetGroups)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_ApplicationTargetProps(o);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedTaskImageProps(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsFargateService(p) {
}
function _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsServiceBaseProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.loadBalancers != null)
            for (const o of p.loadBalancers)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_NetworkLoadBalancerProps(o);
        if (p.targetGroups != null)
            for (const o of p.targetGroups)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_NetworkTargetProps(o);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedTaskImageProps(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedTaskImageProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.secrets != null)
            for (const o of Object.values(p.secrets))
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_Secret(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_NetworkLoadBalancerProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.listeners != null)
            for (const o of p.listeners)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_NetworkListenerProps(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_NetworkListenerProps(p) {
}
function _aws_cdk_aws_ecs_patterns_NetworkTargetProps(p) {
}
function _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsServiceBase(p) {
}
function _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsEc2ServiceProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_PlacementConstraint(o);
        if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/aws-ecs/.warnings.jsii.js")._aws_cdk_aws_ecs_PlacementStrategy(o);
        if (p.loadBalancers != null)
            for (const o of p.loadBalancers)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_NetworkLoadBalancerProps(o);
        if (p.targetGroups != null)
            for (const o of p.targetGroups)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_NetworkTargetProps(o);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedTaskImageProps(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsEc2Service(p) {
}
function _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsFargateServiceProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.loadBalancers != null)
            for (const o of p.loadBalancers)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_NetworkLoadBalancerProps(o);
        if (p.targetGroups != null)
            for (const o of p.targetGroups)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_ecs_patterns_NetworkTargetProps(o);
        if (!visitedObjects.has(p.taskImageOptions))
            _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedTaskImageProps(p.taskImageOptions);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsFargateService(p) {
}
function print(name, deprecationMessage) {
    const deprecated = process.env.JSII_DEPRECATED;
    const deprecationMode = ["warn", "fail", "quiet"].includes(deprecated) ? deprecated : "warn";
    const message = `${name} is deprecated.\n  ${deprecationMessage.trim()}\n  This API will be removed in the next major release.`;
    switch (deprecationMode) {
        case "fail":
            throw new DeprecationError(message);
        case "warn":
            console.warn("[WARNING]", message);
            break;
    }
}
function getPropertyDescriptor(obj, prop) {
    const descriptor = Object.getOwnPropertyDescriptor(obj, prop);
    if (descriptor) {
        return descriptor;
    }
    const proto = Object.getPrototypeOf(obj);
    const prototypeDescriptor = proto && getPropertyDescriptor(proto, prop);
    if (prototypeDescriptor) {
        return prototypeDescriptor;
    }
    return {};
}
const visitedObjects = new Set();
class DeprecationError extends Error {
    constructor(...args) {
        super(...args);
        Object.defineProperty(this, "name", {
            configurable: false,
            enumerable: true,
            value: "DeprecationError",
            writable: false,
        });
    }
}
module.exports = { print, getPropertyDescriptor, DeprecationError, _aws_cdk_aws_ecs_patterns_QueueProcessingEc2ServiceProps, _aws_cdk_aws_ecs_patterns_QueueProcessingEc2Service, _aws_cdk_aws_ecs_patterns_QueueProcessingFargateServiceProps, _aws_cdk_aws_ecs_patterns_QueueProcessingFargateService, _aws_cdk_aws_ecs_patterns_QueueProcessingServiceBaseProps, _aws_cdk_aws_ecs_patterns_QueueProcessingServiceBase, _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedEc2ServiceProps, _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedEc2Service, _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedFargateServiceProps, _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedFargateService, _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedServiceRecordType, _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedServiceBaseProps, _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedTaskImageOptions, _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedServiceBase, _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedEc2ServiceProps, _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedEc2Service, _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedFargateServiceProps, _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedFargateService, _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedServiceRecordType, _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedServiceBaseProps, _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedTaskImageOptions, _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedServiceBase, _aws_cdk_aws_ecs_patterns_ScheduledEc2TaskProps, _aws_cdk_aws_ecs_patterns_ScheduledEc2TaskImageOptions, _aws_cdk_aws_ecs_patterns_ScheduledEc2TaskDefinitionOptions, _aws_cdk_aws_ecs_patterns_ScheduledEc2Task, _aws_cdk_aws_ecs_patterns_ScheduledFargateTaskProps, _aws_cdk_aws_ecs_patterns_ScheduledFargateTaskImageOptions, _aws_cdk_aws_ecs_patterns_ScheduledFargateTaskDefinitionOptions, _aws_cdk_aws_ecs_patterns_ScheduledFargateTask, _aws_cdk_aws_ecs_patterns_ScheduledTaskBaseProps, _aws_cdk_aws_ecs_patterns_ScheduledTaskImageProps, _aws_cdk_aws_ecs_patterns_ScheduledTaskBase, _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsServiceBaseProps, _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancedTaskImageProps, _aws_cdk_aws_ecs_patterns_ApplicationTargetProps, _aws_cdk_aws_ecs_patterns_ApplicationLoadBalancerProps, _aws_cdk_aws_ecs_patterns_ApplicationListenerProps, _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsServiceBase, _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsEc2ServiceProps, _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsEc2Service, _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsFargateServiceProps, _aws_cdk_aws_ecs_patterns_ApplicationMultipleTargetGroupsFargateService, _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsServiceBaseProps, _aws_cdk_aws_ecs_patterns_NetworkLoadBalancedTaskImageProps, _aws_cdk_aws_ecs_patterns_NetworkLoadBalancerProps, _aws_cdk_aws_ecs_patterns_NetworkListenerProps, _aws_cdk_aws_ecs_patterns_NetworkTargetProps, _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsServiceBase, _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsEc2ServiceProps, _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsEc2Service, _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsFargateServiceProps, _aws_cdk_aws_ecs_patterns_NetworkMultipleTargetGroupsFargateService };
